<template>
  <div class="account-user-resource">
    <resource />
    <ob-button
        class="account-user-resource--button account-button"
        v-if="showButton"
        @click="acceptResource"
        label="Назначить ресурс"
        :disabled="hasDisabled"
    />
  </div>
</template>

<script>
import resource from '../../components/resource';
import ObButton from 'common-components/src/obComponents/obButton';
import { mapActions, mapGetters } from 'vuex';
import STEPS from '@/constants/steps.js';

export default {
  components: { resource, ObButton },
  data() {
    return {
      price: 0,
      STEP: STEPS
    }
  },
  computed: {
    ...mapGetters({
      order: 'account/order',
      buttonAcceptResource: 'account/buttonAcceptResource',
      canSubmitDoc: 'account/canSubmitDoc',
      requiredResourcesValues: 'account/requiredResourcesValues',
      contractorUuid: 'user/participantUuid',
      resources: 'account/resources'
    }),
    isMainOrder () {
      return this.contractorUuid === this.order?.contractorUuid
    },
    showButton () {
      return this.buttonAcceptResource ? this.buttonAcceptResource :
        this.order.status === this.STEP.WINNER && this.order.orderStatus === this.STEP.BOOKED ||
        this.order.status === this.STEP.COMPLETED && this.order.orderStatus === this.STEP.BOOKED ||
        this.order.carrierSearchType === this.STEP.OFFER && this.order.orderStatus === this.STEP.BOOKED
    },
    hasDisabled () {
      if (!this.order.isEditable || !this.isMainOrder) return true

      return this.buttonAcceptResource ? this.buttonAcceptResource : this.requiredResourcesList?.length !== this.resources?.length
    },
    currentServiceType () {
      return this.requiredResourcesValues?.[this.order.uuid] || {}
    },
    requiredResourcesList () {
      return this.currentServiceType?.requiredResources || []
    }
  },
  methods: {
    ...mapActions({
      acceptOrder: 'account/acceptOrder',
      acceptResource: 'account/acceptResource',
      requestExecution: 'account/requestExecution'
    })
  },
}
</script>

<style lang="scss" scoped>
 .account-user-resource {
   padding: 20px 0;
   &--button{
     margin: 20px auto;
   }
 }

  ::v-deep {
    .ob-button-container.primary-type {
      background: $color-blue-navy-blue !important;
      color: $style-white !important;
      &.disabled {
        background: $gray-200 !important;
        color: $gray-slate !important;
      }
    }
  }
</style>
